import java.util.HashSet; // 必ず必要 java.util.* でもOK
import java.util.Iterator; // 必ず必要 java.util.* でもOK

/**
 HashSetの動作サンプル JDK5版
 */
public class Sample{
	/**
	Student専用の集合を定義
	*/
	static HashSet<Student> set=new HashSet<Student>();

	/**
	リストの内容を表示，とりあえず名前と数学の点数のみ．
	*/
	static void print(){
		for(Iterator<Student> i=set.iterator(); i.hasNext(); ){
			Student s=i.next(); // 取り出す際，キャストは不必要
			System.out.print(s.name+" "); // 名前を列挙．
		}
		System.out.println();

		// JDK5以降の書き方
		for(Student s: set){
			System.out.print(s.math+" ");
		}
		System.out.println();
	}

	public static void main(String[] args){
		Student tanaka = new Student("tanaka", 90, 80, 20);
		Student tokuta = new Student("tokuta", 70, 60, 40);
		Student yamada = new Student("yamada", 60, 50, 50); 
		Student sasaki = new Student("sasaki", 50, 40, 60);

		set.add(tanaka);
		set.add(tokuta);
		set.add(yamada);
		set.add(sasaki);

		print();

		// {tanaka, tokuta, yamada, sasaki} ∪ {yamada}
		// ⇒ {tanaka, tokuta, yamada, sasaki}
		set.add(yamada);
		print();

		// 差集合
		// {tanaka, tokuta, yamada, sasaki} - {tanaka}
		// ⇒ {tokuta, yamada, sasaki}
		set.remove(tanaka);
		print();

		// 含まれるかどうかの判定 
		// {tokuta, yamada, sasaki} ∋ tokuta
		if(set.contains(tokuta)){
			System.out.println(tokuta.name+" is contained.");
		}
	}
}
